// investing.as

/* ---------------- INCLUDE LIBRARIES ------------------- */

#include "MovieClip_extensions.as"
#include "Array_extensions.as"
#include "TextField_extensions.as"
#include "color_extensions.as"
#include "easing.as"
#include "Answerbox.as"
#include "Buttonbox.as"
#include "event_queue.as"

/* ---------------- DECLARATION ------------------- */

// _root variables

var debug = true;

_global.jdgButtonHold = false;
var depthCount = 50;
var attachedMcs = [];
var hiddenBoxMcs = [];
var buttonBlinkRate = 500; //ms
var swfRoot = _root;
var firstPlay = true;
var turnInProgress = false;

var spinnerActive = false;

var questionCount;
var questionOrder = [];
var totalSpaces = 24;

var spinList = [];

var turnsLeft;
var lastAnswer;
var playerSpace;
var playerScore;
var playerMisses;
var hackersPassed;
var currentQuestionIsPrize;
var updateScore;
var answeredOneCorrect;

var quboxPos = [64,42];

var boxStart = [45, 50];
var boxSpacing = [140, 113];

var continueButtonPos = [178, 363];

var questionTextPadding = 22;
var answerTextPadding = 6;

var answerBoxYSpacing = 8;
var answerBoxIndent = 24;

var soundPlaying = true;
var carSound, scoreSound;
var fadedSoundVolume = 10;
var soundFadeDuration = 31;

//                     [normal,   rollover, dead,     correct/selected, incorrect/selected, correct/unselected]
var ansboxBgColors =   [0xffffff, 0xffffff, 0xffffff, 0x5B8F27,         0xA4111F,           0xffffff];
var ansboxOlColors =   [0x0054a5, 0xffbf00, 0xb9cce9, 0x5B8F27,         0xA4111F,           0x5B8F27];
var ansboxTextColors = [0x0054a5, 0x0054a5, 0xb9cce9, 0xFFFFFF,         0xFFFFFF,           0x5B8F27];

// [normal, rollover, dead]
var barbtnBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var barbtnOlColors = [0xFFFFFF,0xFFC20E,0xFFFFFF];
var barbtnTextColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];

// [normal, rollover, dead]
var contbtnBgColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];
var contbtnOlColors = [0x0054a5,0xffbf00,0xb9cce9];
var contbtnTextColors = [0x0054a5,0x005CAC,0xb9cce9];

var ansboxTf = new TextFormat ();
ansboxTf.align = 'left';
ansboxTf.font = 'f_TheSansBold';
ansboxTf.size = 12;
ansboxTf.color = 0x0054a5;

var ansboxItalicTf = new TextFormat ();
//ansboxItalicTf.align = 'left';
ansboxItalicTf.font = 'f_TheSansBoldItalic';
//ansboxItalicTf.size = 12;
//ansboxItalicTf.color = 0x0054a5;

var ansboxBoolTf = new TextFormat ();
ansboxBoolTf.align = 'center';
ansboxBoolTf.font = 'f_TheSansBold';
ansboxBoolTf.size = 12;
ansboxBoolTf.color = 0x0054a5;

var questionTf = new TextFormat ();
questionTf.align = 'left';
questionTf.font = 'f_TheSansBold';
questionTf.size = 14;
questionTf.color = 0xb62026;

var questionItalicTf = new TextFormat ();
//questionItalicTf.align = 'left';
questionItalicTf.font = 'f_TheSansBoldItalic';
//questionItalicTf.size = 15;
//questionItalicTf.color = 0xb62026;

var explanationTf= new TextFormat ();
explanationTf.align = 'left';
explanationTf.font = 'f_TheSansBold';
explanationTf.color = 0x0054a5;
explanationTf.size = 13;

var explanationItalicTf = new TextFormat ();
//explanationItalicTf.align = 'left';
explanationItalicTf.font = 'f_TheSansBoldItalic';
//explanationItalicTf.color = 0x0054a5;
//explanationItalicTf.size = 14;

/* ---------------- SOUNDS ------------------- */

var queuedSound;
var soundLoadQueue = [];
var soundList = [];
loadQueuedSound = function () {
	debug_trace ('loaded queuedSound: ' + _root.queuedSound.sourcename);
	if (_root.queuedSound.ambient) {
		_root.queuedSound.start (0,1000);
		_root.queuedSound.playing = true;
	}
	if (_root.soundLoadQueue.length > 0) {
		var qs = _root.soundLoadQueue.pop ();
		_root.queuedSound = qs;
		if (qs.external) {
			debug_trace ('loading queuedSound: ' + qs.sourcename);
			qs.onLoad = _root.loadQueuedSound;
			qs.loadSound (qs.sourcename);
		} else {
			debug_trace ('attaching queuedSound: ' + qs.sourcename);
			qs.attachSound (qs.sourcename);
			_root.loadQueuedSound ();
		}
	}
}

// soundList [id, sourcename, external, looping, ambient, fadeVolume]

// soundList.push (['rhythm','wireless_pizz_loop.mp3',true,true,true,50]);
// soundList.push (['cello','wireless_cello_loop.mp3',true,true,true,0]);
// soundList.push (['clarinet','wireless_clarinet_loop.mp3',true,true,true,0]);
// soundList.push (['hackerDie', 's_hackerDie', false, false, false, 100]);
// soundList.push (['question', 's_question', false, false, false]);

soundList.push (['car_old', 'investing_car_old.mp3', true, false, false, 0]);
soundList.push (['car_new', 'investing_car_new.mp3', true, false, false, 0]);
soundList.push (['ending', 'investing_ending.mp3', true, false, false, 100]);
soundList.push (['correct', 's_correct', false, false, false, 100]);
soundList.push (['incorrect', 's_incorrect', false, false, false, 100]);
soundList.push (['appear', 's_appear', false, false, false, 100]);
soundList.push (['disappear', 's_disappear', false, false, false, 100]);

for (var i in soundList) {
	_root['sound_' + soundList[i][0]] = new Sound (_root);
	var sRef = _root['sound_' + soundList[i][0]];
	sRef.sourcename = soundList[i][1];
	sRef.external = soundList[i][2];
	sRef.looping = soundList[i][3];
	sRef.ambient = soundList[i][4];
	sRef.fadeVolume = soundList[i][5];
	_root.soundLoadQueue.push (sRef);
	soundList[i] = sRef;
}

_root.createEmptyMovieClip ('i_soundFader', newMcDepth () );

_root.i_soundFader.unfadeSounds = function () { // 'in', 'out'
	debug_trace ('unfadeSounds');
	for (var i in _root.soundList) {
		_root.soundList[i].setVolume (100);
	}
}

_root.i_soundFader.fadeSounds = function (dir) { // 'in', 'out'
	debug_trace ('fadeSounds');
	this.direction = dir;
	this.fadeSteps = _root.soundFadeDuration;
	this.stepCount = 0;
	this.fadeList = [];
	for (var i in _root.soundList) {
		if (_root.soundList[i].fadeVolume < 100) {
			debug_trace (_root.soundList[i].sourcename)
			var tVol = (dir == 'in') ? 100 - _root.soundList[i].fadeVolume : _root.soundList[i].fadeVolume - 100;
			var dVol = (dir == 'in') ? 100 : _root.soundList[i].fadeVolume;
			this.fadeList.push ([_root.soundList[i],_root.soundLIst[i].getVolume (), tVol, dVol]);
		}
	}
	this.onEnterFrame = function () { this.fadeStep () };
}

_root.i_soundFader.fadeStep = function () {
	if (this.stepCount <= this.fadeSteps) {
		for (var i in this.fadeList) {
			var newVol = Math.linearTween (this.stepCount, this.fadeList[i][1], this.fadeList[i][2], this.fadeSteps);
			this.fadeList[i][0].setVolume (newVol);
		}
		this.stepCount ++;
	} else {
		for (var i in this.fadeList) {
			this.fadeList[i][0].setVolume (this.fadeList[i][3]);
		}
		this.onEnterFrame = null;
		delete this.fadeList;
		delete this.stepCount;
		delete this.fadeSteps;
	}
}

startSoundtrack = function () {
	for (var i in _root.soundList) {
		if (!_root.soundList[i].playing && _root.soundList[i].ambient) {
			_root.soundList[i].start (0,1000);
			_root.soundList[i].playing = true;
		}
	}
	_root.soundPlaying = true;
}

stopSoundtrack = function () {
	for (var i in _root.soundList) {
		_root.soundList[i].stop ();
		_root.soundList[i].playing = false;
	}
	_root.soundPlaying = false;
}

toggleSound = function () {
	if (_root.soundPlaying) {
		_root.stopSoundtrack ();
	} else {
		_root.startSoundtrack ();
	}
}

/* ---------------- CLASSES ------------------- */

Object.registerClass ('m_smallbtn', Buttonbox);
Object.registerClass ('m_btnClose', Buttonbox);
Object.registerClass ('m_btnReplay', Buttonbox);

Array.sum = function () {

}

/* ---------------- FUNCTIONS ------------------- */

debug_trace = function (a) {
	if (debug) {
		trace (a);
	}
}

newMCDepth = function () {
	return depthCount ++;
}

endWait = function () {
	_level0.i_eventQueue.endWait ();
}

returnRandomArray = function (a) {
	var rand, tempArray = [], rtnArray = [];
	tempArray = tempArray.concat (a);
	while (tempArray.length) {
		rand = Math.floor (Math.random () * tempArray.length);
		rtnArray.push (tempArray[rand]);
		tempArray.splice (rand, 1);
	}
	return rtnArray;
}

startGame = function () {
	Mouse.show ();
	_root.turnsLeft = 7;
	_root.lastAnswer = false;
	_root.playerSpace = 0;
	_root.playerScore = 0;
	_root.playerMisses = 0;
	_root.hackersPassed = 0;
	_root.answeredOneCorrect = false;
	_root.currentQuestionIsPrize = true;
	_root.updateScore = false;
	_root.setTurnInProgress (false);
	if (_root.firstPlay) {
		_root.loadQueuedSound ();
		_root.showBreaker ();
	} else {
		for (var i in _root.attachedMcs) { 
			_root.attachedMcs[i].stop (); 
			_root.attachedMcs[i].onEnterFrame = null; 
			_root.attachedMcs[i].removeMovieClip ();
		}
		_root.attachedMcs = [];
		_level0.i_eventQueue.addWait (2);
		_level0.i_eventQueue.addEvent (_root, 'initMovie', null, false);
		for (var i in _root.soundList) {
			_root.soundList[i].setVolume (100);
		}
	}
}

showBreaker = function () {
	_root.attachNewMc (_root, 'm_scr_intro', 'i_scr_intro');
	_root.i_scr_intro.onRelease = function () { _root.endBreaker (); }
}

endBreaker = function () {
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'tweenTo', [[['_alpha',0]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'removeMovieClip', null, false);
	_root.buildXML ('investing_quizdata_es','quizdata');
}

endGame = function () {
	getURL ('javascript:window.close ();');
}

showOgolPage = function (l) {
	if (l == 'es') {
		getURL ("http://alertaenlinea.gov/investing.html", "_blank");
	} else {
		getURL ("http://onguardonline.gov/investing.html", "_blank");
	}
}

replayGame = function () {
	_root.firstPlay = false;
	startGame ();
}

attachNewMc = function (mc, libname,instname) {
	if (libname != null) {
		mc.attachMovie (libname, instname, newMCDepth () );
	} else {
		mc.createEmptyMovieClip (instname, newMcDepth () );
	}
	_root.attachedMcs.push (_root[instname]);
}

buildXML = function (a,name) {	// create XML object from file
	debug_trace ('buildXML');
	_root[name] = new XML ();
	_root[name].ignoreWhite = true;
	_root[name].onLoad = _root.xmlloadingDone;
	_root[name].load (a + '.xml');
}

xmlLoadingDone = function (b) {
	debug_trace ('xmlLoadingDone');
	initMovie ();
}

answerboxClicked = function (box) {
	debug_trace ('answerboxClicked');
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].kill ();
	}
	_root.i_qubox.i_explanationText.htmlText = box.explanationText;
	_root.i_qubox.i_explanationText.hide ();
	_root.lastAnswer = box.correct;
	_root.carSound.stop ();
	_root.i_soundFader.unfadeSounds ();
	if (box.correct) {
		if (_root.soundPlaying) {
			debug_trace ('sound_correct');
			_level0.i_eventQueue.addEvent (_root.sound_correct, 'start', null, false);
		}
	} else {
		if (_root.soundPlaying) {
			debug_trace ('sound_incorrect');
			_level0.i_eventQueue.addEvent (_root.sound_incorrect, 'start', null, false);
		}
		_root.i_qubox.i_explanationText.setTextFormat (_root.explanationIncorrectTf);
	}
	_root.i_qubox.i_explanationText.setTextFormat (_root.explanationTf);
	_root.i_qubox.i_explanationText.italicize (_root.explanationItalicTf);
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_explanationText, 'show', null, false);
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_buttonContinue, 'show', null, false);
}

continueButtonClicked = function () {
	_root.endQuestion ();
}

updateScoreDisplay = function () {
	debug_trace ('updateScoreDisplay');
	debug_trace ('----\nscore: ' + _root.playerScore + '\nhackers passed: ' + _root.hackersPassed);

	if (_root.updateScore) {
		var tgtFrame = _root.playerScore * 10;
		var startFrame = _root.i_score._currentframe;
		var dir = Math.abs (tgtFrame - startFrame) / (tgtFrame - startFrame);
		tgtFrame += dir;
		_level0.i_eventQueue.addEvent (_root.i_score.i_scorePig, 'gotoAndPlay', 2, false);
		_level0.i_eventQueue.addWait (17);
		if (_root.soundPlaying) {
			_root.scoreSound = (tgtFrame == 1) ? _root.sound_appear : _root.sound_disappear;
			_level0.i_eventQueue.addEvent (_root.scoreSound, 'start', null, false);
		}
		var carFrame = (_root.playerScore > 0) ? 2 : 1;
		_level0.i_eventQueue.addEvent (_root.i_carMove.i_car, 'gotoAndStop', carFrame, null);
		for (var i=startFrame; i!=tgtFrame; i+=dir) {
			_level0.i_eventQueue.addEvent (_root.i_score, 'gotoAndStop', i, false);
			_level0.i_eventQueue.addWait (1);
		}
	}
	
	
//  turns left?
	if (_root.turnsLeft > 0) {
		_level0.i_eventQueue.addEvent (_root, 'showIqInstructions', null, false);
		_level0.i_eventQueue.addEvent (_root, 'setTurnInProgress', false, false);
//		_root.turnInProgress = false;
	} else {
		_root.showEnding ();
	}
}

setTurnInProgress = function (b) {
	debug_trace ('setTurnInProgress: ' + b);
	_root.turnInProgress = b;
	_root.i_spinner.useHandCursor = !b;
}

toggleHouseGraphics = function () {
	debug_trace ('toggleHouseGraphics');
	if (_root.lastAnswer) {
		_root.i_score.i_foreclosed.hide ();
	} else {
		_root.i_score.i_poof.play ();
		_root.i_score.i_foreclosed.show ();
	}
}

showQuestionBg = function () {
	debug_trace ('showQuestionBg');
	_root.i_qubox.i_text.htmlText = '';
	_root.i_qubox._xscale = 10;
	_root.i_qubox._yscale = 10;
	_root.i_qubox._alpha = 0;
	_root.i_qubox._visible = true;

	var tweenArray = [];
	tweenArray.push (['_x',_root.quboxPos[0]]);
	tweenArray.push (['_y',_root.quboxPos[1]]);
	tweenArray.push (['_xscale',100]);
	tweenArray.push (['_yscale',100]);
	tweenArray.push (['_alpha',100]);

	_level0.i_eventQueue.addEvent (_root, 'moveQuestionBg', null, false);
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [tweenArray, 10], true);
	_level0.i_eventQueue.addEvent (_root.i_soundFader, 'fadeSounds', 'out', false);
}

moveQuestionBg = function () {
	debug_trace ('moveQuestionBg: ' + _root.i_carmove.i_car.getGlobalCoords ());
	_root.i_qubox.moveToA (_root.i_carmove.i_car.getGlobalCoords ());
}

endQuestion = function () {
	debug_trace ('endQuestion');
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [[['_alpha',0]], 10], true);
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].removeMovieClip ();
	}
	_root.i_qubox.i_questionText.htmlText = '';
	_root.i_qubox.i_explanationText.htmlText = '';
	_root.i_qubox.i_buttonContinue.hide ();
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'hide', null, false);
//	process correct answer
	if (_root.lastAnswer) {
		_root.answeredOneCorrect = true;
		if (_root.currentQuestionIsPrize) {
			_root.playerScore += 1;
			_root.updateScore = true;
			_root.i_iqPopups.gotoAndStop (_root.playerScore);
			_root.i_iqPopups._alpha = 0;
			_root.i_iqPopups.show ();
			_root.i_iqPopups.nextAction = _root.updateScoreDisplay;
			_level0.i_eventQueue.addEvent (_root.i_iqPopups, 'tweenTo', [[['_alpha',100]],10], true);
		} else {
			_root.hackersPassed += 1;
			_root.updateScore = false;
			_root.i_hackerPopups.gotoAndStop (3 * (_root.hackersPassed - 1) + 2);
			_root.i_hackerPopups._alpha = 0;
			_root.i_hackerPopups.show ();
			_root.i_hackerPopups.nextAction = _root.updateScoreDisplay;
			_level0.i_eventQueue.addEvent (_root.i_hackerPopups, 'tweenTo', [[['_alpha',100]],10], true);
		}
	} else {
		_root.playerMisses ++;
		debug_trace ('playerMisses:  ' + _root.playerMisses);
		if (_root.playerMisses < 2 && _root.turnsLeft > 0) {
			_root.turnsLeft ++;
			debug_trace ('turnsLeft:  ' + _root.turnsLeft);
			_root.spinList = _root.buildSpinList (_root.totalSpaces - _root.playerSpace, _root.turnsLeft);
		}
		if (!_root.currentQuestionIsPrize) {
			_root.playerScore -= 1;
			_root.updateScore = true;
			_root.i_hackerPopups.gotoAndStop (3 * _root.hackersPassed + 3);
			_root.i_hackerPopups._alpha = 0;
			_root.i_hackerPopups.show ();
			_root.i_hackerPopups.nextAction = _root.updateScoreDisplay;
			_level0.i_eventQueue.addEvent (_root.i_hackerPopups, 'tweenTo', [[['_alpha',100]],10], true);
		} else {
			_root.updateScore = false;
			_root.updateScoreDisplay ();
		}
	}
}

showQuestion = function (num) {
	debug_trace ('showQuestion');
	var qNode = _root.quizdata.firstChild.childNodes[num];
	var questionType = qNode.attributes.questionType;
	var ySpace = (questionType == 'boolean') ? _root.answerBoxYSpacing * 2 : _root.answerBoxYSpacing;
	
	var qText = qNode.firstChild.firstChild.nodeValue;
	
	_root.i_qubox.i_questionText.htmlText = qText;
	_root.i_qubox.i_questionText.setTextFormat (_root.questionTf);
	_root.i_qubox.i_questionText.italicize (_root.questionItalicTf);
	_root.i_qubox.i_questionText._height = _root.i_qubox.i_questionText.textHeight + 6;
	var yCursor = _root.i_qubox.i_questionText._y + _root.i_qubox.i_questionText._height + ySpace;
	
	_level0.i_eventQueue.addEvent (_root.sound_question, 'start', null, false);
	_level0.i_eventQueue.addWait (10);
	
	_root.showQuestionBg ();

	for (var i = 0; i < qNode.childNodes[1].childNodes.length; i ++) {
		var ansText = qNode.childNodes[1].childNodes[i].firstChild.firstChild.nodeValue;
		var explText = qNode.childNodes[1].childNodes[i].childNodes[1].firstChild.nodeValue;
		var ansCorrect = qNode.childNodes[1].childNodes[i].attributes.correct;

		attachNewMc (_root.i_qubox, 'm_ansbox', 'i_ansbox'+i);
		var o = _root.i_qubox['i_ansbox'+i];
		_root.i_qubox.answerMcs.push (o);
		o.propOnRelease = _root.answerBoxClicked;
		o.bgColors = _root.ansboxBgColors;
		o.olColors = _root.ansboxOlColors;
		if (questionType == 'boolean') {
			o.textFormat = _root.ansboxBoolTf;
		} else {
			o.textFormat = _root.ansboxTf;
		}
		o.textColors = _root.ansboxTextColors;
		o.textPadding = _root.answerTextPadding;
		o.correct = (ansCorrect == "true") ? true : false;
		o.answerText = ansText;
		o.italicize (_root.ansboxItalicTf);
		o.explanationText = explText;
		o._x = _root.answerBoxIndent;
		o._y = yCursor;
		yCursor += o._height + ySpace;
		o._alpha = 0;
		
		_level0.i_eventQueue.addEvent (o, 'tweenTo', [[['_alpha', 100]], 3], true);
	}

	_root.i_qubox.i_explanationText._y = yCursor;
	yCursor += _root.i_qubox.i_explanationText._height + ySpace;
}

beginTurn = function () {
	debug_trace ('--------\nbeginTurn');
	_root.setTurnInProgress (true);
	_root.i_popupInstructions.removeMovieClip ();
	_root.i_popupInstructions2.removeMovieClip ();
	_root.turnsLeft --;
	debug_trace ('turnsLeft:  ' + _root.turnsLeft);
	var thisSpin = _root.spinList.shift ();
	_root.playerSpace += thisSpin;
	
	if (_root.soundPlaying) {
		_root.carSound = (_root.playerScore == 0) ? _root.sound_car_old : _root.sound_car_new;
		_root.carSound.start ();
	}

	spinNumber (thisSpin);
	moveCarToSpace (_root.playerSpace);
	if (_root.playerScore > _root.hackersPassed) {
		debug_trace ('hacker question');
		_root.currentQuestionIsPrize = false;
		_root.i_hackerPopups.nextAction = _root.showNextQuestion;
		_root.i_hackerPopups.gotoAndStop (3 * _root.hackersPassed + 1);
		_root.i_hackerPopups._alpha = 0;
		_root.i_hackerPopups.show ();
		_level0.i_eventQueue.addEvent (_root.i_hackerPopups, 'tweenTo', [[['_alpha',100]],10], true);
	} else {
		_root.currentQuestionIsPrize = true;
		_root.showNextQuestion ();
	}

}

moveCarToSpace = function (num) {
	debug_trace ('moveCarToSpace: ' + num);
	var tgtFrame = num * 10;
	var startFrame = _root.i_carmove._currentframe;
	var dir = Math.abs (tgtFrame - startFrame) / (tgtFrame - startFrame);
	tgtFrame += dir;
	for (var i=startFrame; i!=tgtFrame; i+=dir) {
		_level0.i_eventQueue.addEvent (_root.i_carmove, 'gotoAndStop', i, false);
		if (i % 10 == 0) {
			_level0.i_eventQueue.addWait (3);
		}
	}
}

spinNumber = function (num) {
	debug_trace ('spinNumber ' + num);
	var startFrame = (num * 60) - 58;
	_level0.i_eventQueue.addEvent (_root.i_spinner, 'gotoAndPlay', startFrame, false);
	_level0.i_eventQueue.addWait (70);
}

buildSpinList = function (s, t) { // spaces to move, turns
	debug_trace ('buildSpinList');
	var tmpList = [], pass = 0;
	if (s == t) {
		for (var i=0; i<t; i++) {
			tmpList.push (1);
		}
	} else if (t == 1) {
		tmpList.push (s);
	} else {
		for (var i=0; i<t; i++) {
			tmpList.push (Math.floor (Math.random () * 6 + 1));
		}
	//	debug_trace ('initial list: ' + tmpList);
	//	debug_trace ('sum: ' + tmpList.sum ());
	
		while (tmpList.sum () != s) {
			pass++;
	//		debug_trace ('--------\npass: ' + pass);
			tmpList.sort ();
			var diff = s - tmpList.sum ();
	//		debug_trace ('diff: ' + diff);
			if (diff > 0) {
				tmpList[0] = (diff + tmpList[0] > 5) ? 6 : diff + tmpList[0];
			} else {
				tmpList[t-1] = (diff - tmpList[t-1] < -5) ? 1 : diff - tmpList[t-1];
			}
	//		debug_trace ('revised list: ' + tmpList);
		}
	
		tmpList.sort ();
	
		if (tmpList[t-1] > (s + 1 - t)) {
	//		debug_trace ('starting over, last spin too small');
			buildSpinList (s, t);
		} else {
			var lastSpin = tmpList.pop ();
			tmpList.randomize ();
			tmpList.push (lastSpin);
			debug_trace ('final list: ' + tmpList + '; sum: ' + tmpList.sum() );
		}
	}
	return tmpList;
}

showIqInstructions = function () {
	debug_trace ('showIqInstructions');
	attachNewMc (_root, 'm_popupInstructions2', 'i_popupInstructions2');
}

showNextQuestion = function () {
	debug_trace ('showNextQuestion');
	var q = _root.questionOrder.pop ();
	_root.showQuestion (q);
}

showEnding = function () {
	debug_trace ('showEnding');
	_root.attachNewMc (_root, 'm_scr_ending', 'i_scr_ending');
	_root.i_scr_ending._alpha = 0;
	_root.i_scr_ending.hide ();
	if (_root.playerMisses == 0) {
		_root.i_scr_ending.gotoAndStop (_root.playerScore + 3);
	} else if (_root.answeredOneCorrect) {
		_root.i_scr_ending.gotoAndStop (_root.playerScore + 2);
	}
	
	_root.attachNewMc (_root.i_scr_ending, 'm_btnReplay', 'i_btnReplay');
	_root.i_scr_ending.i_btnReplay.moveToA ([425,445]);
	_root.i_scr_ending.i_btnReplay.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnReplay.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnReplay.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnReplay.onRelease = function () { _root.replayGame (); }

	_root.attachNewMc (_root.i_scr_ending, 'm_btnClose', 'i_btnClose');
	_root.i_scr_ending.i_btnClose.moveToA ([507,445]);
	_root.i_scr_ending.i_btnClose.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnClose.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnClose.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnClose.onRelease = function () { _root.endGame (); }

	if (_root.soundPlaying) {
		_level0.i_eventQueue.addEvent (_root, 'stopSoundtrack', null, false);
		_level0.i_eventQueue.addEvent (_root.sound_ending, 'start', null, false);
		_root.restartSoundOnReplay = true;
	}
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'show', null, false);
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'tweenTo', [[['_alpha',100]],10], true);
}

/* ---------------- MOVIE INITIALIZATION ------------------- */

initMovie = function () {
	debug_trace ('initMovie');

	_root.i_breaker.removeMovieClip ();
	
	_level0.i_eventQueue.addEvent (_root.i_ringAnimation, 'gotoAndPlay', 'build', false);
	
	_root.questionCount = _root.quizdata.firstChild.childNodes.length;

	_root.questionOrder = [];

	for (var i=0; i<_root.questionCount; i++) {
		_root.questionOrder.push (i);
	}
	_root.questionOrder = returnRandomArray (_root.questionOrder);

	if (_root.restartSoundOnReplay) {
		_root.startSoundtrack ();
	}

	// draw game board
	
	_root.attachNewMc (_root, 'm_bgGame', 'i_bgGame');

	_root.attachNewMc (_root, 'm_carmove', 'i_carmove');
	
	_root.attachNewMc (_root, 'm_spinner', 'i_spinner');
	_root.i_spinner.moveToA ([570,63]);
	_root.i_spinner.onRelease = function () { 
		if (!_root.turnInProgress) {
			_root.beginTurn ();
		}
	}

	_root.attachNewMc (_root, 'm_score', 'i_score');
	_root.i_score.i_foreclosed.hide ();

	_root.attachNewMc (_root, 'm_hackerPopups', 'i_hackerPopups');
	_root.i_hackerPopups.stop ();
	_root.i_hackerPopups.hide ();
	_root.i_hackerPopups.nextAction = null;
	_root.i_hackerPopups.onRelease = function () {
		_level0.i_eventQueue.addEvent (this, 'tweenTo', [[['_alpha',0]],10], true);
		_level0.i_eventQueue.addEvent (this, 'hide', null, false);
		_level0.i_eventQueue.addEvent (this, 'nextAction', null, false);
	}

	_root.attachNewMc (_root, 'm_iqPopups', 'i_iqPopups');
	_root.i_iqPopups.stop ();
	_root.i_iqPopups.hide ();
	_root.i_iqPopups.nextAction = null;
	_root.i_iqPopups.onRelease = function () {
		_level0.i_eventQueue.addEvent (this, 'tweenTo', [[['_alpha',0]],10], true);
		_level0.i_eventQueue.addEvent (this, 'hide', null, false);
		_level0.i_eventQueue.addEvent (this, 'nextAction', null, false);
	}
	
	_root.attachNewMc (_root, 'm_b_sound', 'i_buttonSound');
	_root.i_buttonSound.moveToA ([600,445]);
	_root.i_buttonSound.gotoAndStop (_root.soundPlaying ? 1 : 3);
	_root.i_buttonSound.onRelease = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			_root.toggleSound ();
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}
	_root.i_buttonSound.onRollOver = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 2 : 4);
		}
	}
	_root.i_buttonSound.onRollOut = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}

	_root.attachNewMc (_root, 'm_popupInstructions', 'i_popupInstructions');
	_root.i_popupInstructions.stop ();
	
	_level0.i_eventQueue.addWait (31);
	_level0.i_eventQueue.addEvent (_root.i_popupInstructions, 'gotoAndPlay', '2', false);


	// set up question box
	
	_root.attachNewMc (_root, 'm_qubox', 'i_qubox');
	_root.i_qubox._visible = false;
	_root.i_qubox.answerMcs = [];
	
	_root.attachNewMc (_root.i_qubox, 'm_smallbtn', 'i_buttonContinue');
	_root.i_qubox.i_buttonContinue.moveToA (_root.continueButtonPos);
//	_root.i_qubox.i_buttonContinue.__proto__ = Buttonbox.prototype;
	_root.i_qubox.i_buttonContinue.bgColors = _root.contbtnBgColors;
	_root.i_qubox.i_buttonContinue.olColors = _root.contbtnOlColors;
	_root.i_qubox.i_buttonContinue.textColors = _root.contbtnTextColors;
	_root.i_qubox.i_buttonContinue.hide ();
	_root.i_qubox.i_buttonContinue.onRelease = function () { _root.continueButtonClicked (); }

	_root.i_qubox.createTextField ('i_questionText', 1, _root.questionTextPadding, _root.questionTextPadding * .6, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var o = _root.i_qubox.i_questionText;
	o.multiline = true;
	o.wordWrap = true;
	o.embedFonts = true;
	o.selectable = false;
	o.html = true;
	o.setNewTextFormat (_root.questionTf);
	
	_root.i_qubox.createTextField ('i_explanationText', 2, _root.questionTextPadding, 480, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var p = _root.i_qubox.i_explanationText;
	p.multiline = true;
	p.wordWrap = true;
	p.embedFonts = true;
	p.selectable = false;
	p.html = true;
	p.setNewTextFormat (_root.explanationTf);
	p._visible = false;
	
	_root.spinList = _root.buildSpinList (_root.totalSpaces - _root.playerSpace, _root.turnsLeft);
	
}


/* ---------------- RUNTIME ------------------- */

if (_root == _level0) { 
	startGame ();
}
